/// Josh's User Interface Library
/// A C++20 Library for creating, styling, and rendering of a UI/UX widgets.
/// Developed and Maintained by Josh O'Leary @ Redacted Software.
/// Special Thanks to William Tomasine II and Maxine Hayes.
/// (c) 2024 Redacted Software
/// This work is dedicated to the public domain.

/// @file UDim2.hpp
/// @desc Universal Dimensions 2D Class
/// @edit 2024-07-10

#pragma once

#include <JUI/Base/Widget.hpp>
#include <JUI/Base/RectBase.hpp>

namespace JUI {

    /// The Rect Widget Class.
    /// Renders a rectangle or "box" and also serves as a vesatile container for laying out other widgets.
    class Rect : public Widget, public RectBase {
    public: /// Constructors
        /// The default constructor.
        Rect();

        explicit Rect(Widget* parent);

        ~Rect() override {}

        bool IsMouseInside() const;
    public:
        void Draw() override;
        void Update(float delta) override;

    };
}