#include <JUI/Base/ImageBase.hpp>
#include <JGL/JGL.h>

using namespace JGL;

namespace JUI
{
    void ImageBase::Draw(const Vector2 &pos, const Vector2 &size) {
        J2D::Begin();
        // TODO: Support image rotation in the widget.
        J2D::DrawSprite(*texture, pos, 0, origin, scale, image_color);
        J2D::End();
    }

    ImageBase::ImageBase()
    {

    }

    ImageBase::ImageBase(JGL::Texture* tex) : ImageBase()
    {
        this->texture = tex;
    }

    void ImageBase::SetContent(JGL::Texture *content) {
        this->texture = content;
    }

    void ImageBase::Color(const Color4 &newColor) { this->image_color = newColor;}

    void ImageBase::Scale(const Vector2 &newScale) { scale = newScale;}

    void ImageBase::Origin(const Vector2 &newOrigin) { origin = newOrigin; }
}

